# coding: utf-8

"""
    Gitea API.

    This documentation describes the Gitea API.

    The version of the OpenAPI document: 1.19.4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, StrictBool, StrictInt, StrictStr
from py_gitea_opensuse_org.models.repository import Repository

class DeployKey(BaseModel):
    """
    DeployKey a deploy key
    """
    created_at: Optional[datetime] = None
    fingerprint: Optional[StrictStr] = None
    id: Optional[StrictInt] = None
    key: Optional[StrictStr] = None
    key_id: Optional[StrictInt] = None
    read_only: Optional[StrictBool] = None
    repository: Optional[Repository] = None
    title: Optional[StrictStr] = None
    url: Optional[StrictStr] = None
    __properties = ["created_at", "fingerprint", "id", "key", "key_id", "read_only", "repository", "title", "url"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DeployKey:
        """Create an instance of DeployKey from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of repository
        if self.repository:
            _dict['repository'] = self.repository.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DeployKey:
        """Create an instance of DeployKey from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DeployKey.parse_obj(obj)

        _obj = DeployKey.parse_obj({
            "created_at": obj.get("created_at"),
            "fingerprint": obj.get("fingerprint"),
            "id": obj.get("id"),
            "key": obj.get("key"),
            "key_id": obj.get("key_id"),
            "read_only": obj.get("read_only"),
            "repository": Repository.from_dict(obj.get("repository")) if obj.get("repository") is not None else None,
            "title": obj.get("title"),
            "url": obj.get("url")
        })
        return _obj


